#define FILE_NAME "Tsp.c"

#if defined(PDEF_H)

#include "../anneal.h"

LIST("# " FILE_NAME " version 8.16")
REAL(Err,-306,       EJ("Err in addition order","û㤤"))
REAL(Min,-306,       EJ("True best score","κûΥ"))
INT(N,      3,       EJ("Number of nodes","ˬ䤹ο"))
CDEF(Name,  6,N,     EJ("Code Name","ˬϤ̾"))
RVEC(X,   306,N,     EJ("position X.","ˬϤΰ֤򼨤غɸ"))
RVEC(Y,   306,N,     EJ("position Y.","ˬϤΰ֤򼨤ٺɸ"))
CVEC(Order, 5,N,Name,EJ("Annealing result","륹ޥˬ䤹"))
RMAT(Dist,306,N,N,   EJ("Distance matrix","Υι"))
RVEC(Small,306,N,    EJ("Accending dist","Υ򾮤"))
INT(EN,     3,       EJ("Execution count","¸"))
INT(AN,     4,       EJ("Annealing count","ˡ󥰲"))
INT(MW,     3,       EJ("Width of map","Ͽޤ"))
INT(MN,     3,       EJ("Line num of map","ϿޤιԿ"))
INT(EnCnt,  3,       EJ("Curr Exec","¸ֹ"))
SVEC(Map,   0,MN,    EJ("Map of nodes","ˬϤΰ֤򼨤Ͽ"))
STR(FName,  5,       EJ("FastTest file name","FastTest Υե̾"))
PROC(Length, EJ("Length","륹ޥΰưΥCurrScore"))
PROC(Draw,   EJ("Draw map","Ͽޤơ'Map'񤭽Ф"))
PROC(Test,   EJ("Test all space","Ĵ٤"))
PROC(TestOne,EJ("Test all space","Ĵ٤"))
PROC(MakeData,EJ("Make data","ǡ"))
FUNC(FastTest,EJ("Test all space(fast)","Ĵ٤(®)"))
AUTO("Range N  >= 4")
AUTO("Range EN >= 4")
AUTO("Range MW >= 2 <= 200")
AUTO("Range MN >= 2 <= 200")
AUTO("Err   EN AN  MW")
#if FLOAT_REAL
AUTO("1e-4 10 100 67")
#else
AUTO("1e-12 10 100 67")
#endif

#else

 #if defined(__TURBOC__) && !defined(__BORLANDC__)
  #define NO_ADD   1
  #define NO_SORT  1
  #define NO_NINT  1
 #endif
 #if defined(LSI_C)
  #define ASCII       1
  #define NO_VERSION  1
  #define NO_NINT     1
  #define NO_FAST_STR 1
  #define NO_ADD      1
  #define NO_ALIAS    1
  #define NO_APPEND   0
  #define NO_CDEF     0
  #define NO_CLOCK    0
  #define NO_CSV      1
  #define NO_ECHO     0
  #define NO_SORT     1
  #define NO_BOM      1
  #define NO_FORMAT   0
  #define NO_FREE     1
  #define NO_JAG      0
  #define NO_LAP      0
  #define NO_LIMIT    1
  #define NO_LIST     1
  #define NO_OUTPUT   0
  #define NO_PROGRESS 1
  #define NO_RAND     0
  #define NO_RANGE    0
  #define NO_RESET    1
  #define NO_SAVE     1
  #define NO_STR      0
  #define NO_SYSTEM   1
  #define NO_TSV      1
  #define NO_VMJ      1
  #define NO_HUNAME   1
  #define NO_VERSION  1
 #endif

 #include "pocom.h"
 CHECK_FILE_NAME

real BadSum,CSum;
void Draw(void) {
    Int i,j,k,MaxL,Width; real MinX,MinY,MaxX,MaxY,ScaleY,ScaleX,r;
    Check("X Y Name");
    MinX=MaxX=X[0]; MinY=MaxY=Y[0]; MaxL=(Int)strlen(Name[0]);
    for (k=1; k<N; k++) {
        r=X[k]; if (r<MinX) MinX=r; if (r>MaxX) MaxX=r;
        r=Y[k]; if (r<MinY) MinY=r; if (r>MaxY) MaxY=r;
        if ((Int)strlen(Name[k])>MaxL)  MaxL=(Int)strlen(Name[k]);
    }
    Width=MW-MaxL+1; ScaleX=0.99999*Width/(MaxX-MinX);
    ScaleY=0.5*ScaleX; MN=(Int)((MaxY-MinY)*ScaleY)+1;
    SizeChangedBy(MN,Draw); Alloc("Map");
    for (i=0;i<MN;i++) AllocSvec(Map,i,(size_t)MW+1);
    for (i=0;i<MN;i++) for (j=0;j<MW;j++) Map[i][j]=' ';
    for (k=0;k<N;k++)
        memcpy(&Map[(Int)((Y[k]-MinY)*ScaleY)]
                   [(Int)((X[k]-MinX)*ScaleX)],
                Name[k],strlen(Name[k]));
    Print("Map");
}

real FastSum(void) {
    Int i,from=Order[N-1],to; real sum=0.0;
    for (i=0;i<N;i++) { to=Order[i]; sum+=Dist[from][to]; from=to; }
    return sum;
}

real SortedSum(void) {
    Int i,j,from=Order[N-1],to; real r,sum=0.0;
    for (i=0;i<N;i++) { to=Order[i]; Small[i]=Dist[from][to]; from=to; }
    for (i=1;i<N;i++) {
        r=Small[i];
        for (j=i-1;j>=0&&Small[j]>r;j--) Small[j+1]=Small[j];
        Small[j+1]=r;
    }
    for (i=0;i<N;i++) sum+=Small[i];
    return sum;
}

void Length(void) {
    Int i,j; real DifX,DifY; static real x0;
    Check("X");
    if (x0!=X[0]) {
        Check("Order X Y"); Alloc("Dist");
        for (i=0;i<N-1;i++) for (j=i+1;j<N;j++) {
            DifX=X[i]-X[j]; DifY=Y[i]-Y[j];
            Dist[i][j]=Dist[j][i]=sqrt(DifX*DifX+DifY*DifY);
        }
        x0=X[0];
    }
    CurrScore=FastSum();
}

/* ƥȥǡĴ٤ƿκǾͤ */
void GetMin(Int k) {
 #if !NO_PROGRESS || WINDOWS__
    Int i,j,t,cnt=0,add=0; real DifX,DifY,y=0.0,size,group=0.0;
    #define PROG_BASE 6 /* add=6*5*4*3*2 */
    for (size=1.0,i=N-1;i>1;i--) size*=i;
    if (N>PROG_BASE+2) {
        for (add=1,i=PROG_BASE;i>1;i--) add*=i;
        group=size/add;
    }
 #else
    Int i,j,t; real DifX,DifY;
    (void)k;
 #endif

    for (i=0;i<N;i++)
    { Order[i]=i; X[i]=Unif()*20; Y[i]=Unif()*20; }
    for (i=0;i<N-1;i++) for (j=i+1;j<N;j++) {
        DifX=X[i]-X[j]; DifY=Y[i]-Y[j];
        Dist[i][j]=Dist[j][i]=sqrt(DifX*DifX+DifY*DifY);
    }
    Min=1e30;

    /* ʬϤǤηٹ޻ߡAUTO("Range N >= 4")  N>=4 ΤϤ */
    if (N<4) return;

    for (;;) {
        if (Order[1]<Order[N-1]) if (FastSum()<Min) Min=SortedSum();
        for (i=N-2;Order[i]>=Order[i+1];i--) ;
        if (i==0) break;
        for (j=N-1;Order[i]>=Order[j];j--) ;
        t=Order[i]; Order[i]=Order[j]; Order[j]=t; i++;
        for (j=N-1;j>i;j--)
        { t=Order[i]; Order[i]=Order[j]; Order[j]=t; i++; }
 #if !NO_PROGRESS || WINDOWS__
        if (N>PROG_BASE+2) {
            if (y>=group)
            { cnt++; y=0; Progress2("# gen ",k,EN,cnt,add); }
        } else if (y>=size-2.0) Progress("# gen ",k,EN);
        y++;
 #endif
    }
}

void TestOne(void) {
    Int i,j,Bad; real Diff,MaxDiff,tot,DifX,DifY;
    Bad=0; MaxDiff=0; tot=0; Alloc("Name Order Dist Small");
    for (i=0;i<N-1;i++) for (j=i+1;j<N;j++) {
        DifX=X[i]-X[j]; DifY=Y[i]-Y[j];
        Dist[i][j]=Dist[j][i]=sqrt(DifX*DifX+DifY*DifY);
    }
    for (i=0;i<AN;i++) {
        Anneal("Length PermuMove Order REV");
        tot+=Count; Diff=SortedSum()-Min;
        if (Diff<0) Diff=-Diff;
        if (Diff>Err) Bad++;
        if (Diff>MaxDiff) MaxDiff=Diff;
        Progress2("# test ",EnCnt,EN,i,AN);
    }
    BadSum+=Bad; CSum+=tot; EnCnt++;
#if JPN
    fprintf(fp,JP("# Ψ=%5.1f%% Ǿ=%6.2f =%9.1f =%g\n"),
#else
    fprintf(fp,"# Success rate=%5.1f%% Min=%6.2f Num=%9.1f diff=%g\n",
#endif
        100.0*((double)AN-Bad)/AN,(double)Min,tot/AN,(double)MaxDiff);
    FlushFp();
}

/* ƥȥǡȿκǾͤȥƥȤ񤭽Ф */
void MakeData(void) {
    Int k;
    Check("N");
    Alloc("X Y Name Order Dist Small");
    Print("N EN");
    for (k=0;k<EN;k++) {
        GetMin(k);
        Print("N X Y");
        Print("Min");
        Echo("TestOne");
        Echo("");
    }
}

void FastTest(const char*argument) {
    real anen=(real)AN*(real)EN;
    BadSum=0; CSum=0; EnCnt=0;
    CopyArg("FastTest",argument);
    FreeWord(FName);
    SetStr(FName,ReadStr());
    EndArg();
    fprintf(fp,"# %s\n",FName);
    Print("EN AN Sample Crit Gamma Multi Err");
    Load(FName);
#if JPN
    fprintf(fp,JP("# :Ψ=%6.2f%% =%.1f\n"),
#else
    fprintf(fp,"# Total:Success rate=%6.2f%% Num=%.1f\n",
#endif
        100.0*(anen-BadSum)/anen,CSum/anen);
}

void Test(void) {
    Int k; real anen=(real)AN*(real)EN;
    Alloc("X Y Name Order Dist Small"); Check("X");
    Print("N EN AN Sample Crit Gamma Multi Err");
    BadSum=0; CSum=0;
    for (k=0;k<EN;k++) { GetMin(k); TestOne(); }
 #if JPN
    fprintf(fp,JP("# :Ψ=%6.2f%% =%.1f\n"),
 #else
    fprintf(fp,"# Total:Success rate=%6.2f%% Num=%.1f\n",
 #endif
        100.0*(anen-BadSum)/anen,CSum/anen);
}

#endif
